package org.dromara.web.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.web.domain.ProductSupplier;
import org.dromara.web.domain.bo.ProductSupplierBo;
import org.dromara.web.domain.vo.ProductSupplierVo;
import org.dromara.web.mapper.ProductSupplierMapper;
import org.dromara.web.service.IProductSupplierService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 供应商Service业务层处理
 *
 * @author Lion Li
 * @date 2025-07-07
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ProductSupplierServiceImpl implements IProductSupplierService {

    private final ProductSupplierMapper baseMapper;

    /**
     * 查询供应商
     *
     * @param id 主键
     * @return 供应商
     */
    @Override
    public ProductSupplierVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询供应商列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 供应商分页列表
     */
    @Override
    public TableDataInfo<ProductSupplierVo> queryPageList(ProductSupplierBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ProductSupplier> lqw = buildQueryWrapper(bo);
        Page<ProductSupplierVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的供应商列表
     *
     * @param bo 查询条件
     * @return 供应商列表
     */
    @Override
    public List<ProductSupplierVo> queryList(ProductSupplierBo bo) {
        LambdaQueryWrapper<ProductSupplier> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ProductSupplier> buildQueryWrapper(ProductSupplierBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ProductSupplier> lqw = Wrappers.lambdaQuery();
        lqw.orderByDesc(ProductSupplier::getCreateTime);
        lqw.like(StringUtils.isNotBlank(bo.getName()), ProductSupplier::getName, bo.getName());
        return lqw;
    }

    /**
     * 新增供应商
     *
     * @param bo 供应商
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ProductSupplierBo bo) {
        ProductSupplier add = MapstructUtils.convert(bo, ProductSupplier.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改供应商
     *
     * @param bo 供应商
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ProductSupplierBo bo) {
        ProductSupplier update = MapstructUtils.convert(bo, ProductSupplier.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ProductSupplier entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除供应商信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
